﻿using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;

namespace SQLComparator
{
    public class DatabaseInfo
    {
        /// <summary>
        /// 测试数据库连接
        /// </summary>
        /// <param name="serverName"></param>
        /// <returns></returns>
        public static bool TestConnection(string serverName)
        {
            return TestConnection(serverName, null, null);
        }

        /// <summary>
        /// 测试数据库连接
        /// </summary>
        /// <param name="serverName"></param>
        /// <param name="userName"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public static bool TestConnection(string serverName, string userName, string password)
        {
            bool result = false;
            try
            {
                ServerConnection connectionInfo;
                if (string.IsNullOrEmpty(userName) && string.IsNullOrEmpty(password))
                    connectionInfo = new ServerConnection(serverName);
                else
                    connectionInfo = new ServerConnection(serverName, userName, password);

                Server server = new Server(connectionInfo);
                server.ConnectionContext.ConnectTimeout = 1;
                server.ConnectionContext.Connect();
                if (server.ConnectionContext.IsOpen)
                {
                    result = true;
                }
                server.ConnectionContext.Disconnect();
            }
            catch { }

            return result;
        }

        /// <summary>
        /// 测试数据库连接
        /// </summary>
        /// <param name="serverName"></param>
        /// <returns></returns>
        public static Server GetServer(string serverName)
        {
            return GetServer(serverName, null, null);
        }

        /// <summary>
        /// 测试数据库连接
        /// </summary>
        /// <param name="serverName"></param>
        /// <param name="userName"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public static Server GetServer(string serverName, string userName, string password)
        {
            try
            {
                ServerConnection connectionInfo;
                if (string.IsNullOrEmpty(userName) && string.IsNullOrEmpty(password))
                    connectionInfo = new ServerConnection(serverName);
                else
                    connectionInfo = new ServerConnection(serverName, userName, password);

                Server server = new Server(connectionInfo);
                return server;
            }
            catch 
            {
                return null;
            }
        }
    }
}
